------------------------------------------------------------------------------
--                                                                          --
--                  gwindows.edit_boxes.ex_multi_line_edit_boxes            --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--                            $Revision: 1.3 $                              --
--                                                                          --
--                            Konad GmbH 2004                               --
--                                                                          --
-- This is free software;  you can  redistribute it  and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. It is distributed in the hope that it will be useful,  but WITHOUT --
-- ANY WARRANTY;  without  even the  implied warranty of MERCHANTABILITY or --
-- FITNESS FOR A PARTICULAR PURPOSE.    See the GNU General  Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License  distributed with this;  see file COPYING.  If not, write --
-- to  the Free Software Foundation,  59 Temple Place - Suite 330,  Boston, --
-- MA 02111-1307, USA.                                                      --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
-- More information about GWINDOWS and the most current public version can  --
-- be located on the web at http://www.gnavi.org/gwindows                   --
--                                                                          --
------------------------------------------------------------------------------
-- The ex_multi_line_edit_box_type permits customized keyboard behavior.
-- For example you may navigate to the next control if a user presses the
-- TAB key
------------------------------------------------------------------------------
with Gwindows.Windows;
with Gwindows.Base; use Gwindows.Base;
with Gwindows.Colors; use Gwindows.Colors;
with Gwindows.Drawing_Objects; use Gwindows.Drawing_Objects;

package Gwindows.Edit_Boxes.Ex_Multi_Line_Edit_Boxes is

   type Ex_Multi_Line_Edit_Box_Type is
     new Multi_Line_Edit_Box_Type with private;
   type Ex_Multi_Line_Edit_Box_Access is access all
     Ex_Multi_Line_Edit_Box_Type;


   type Character_Event is access
     procedure (Window      : in out ex_multi_line_edit_box_type'Class;
                Special_Key : in     Gwindows.Windows.Special_Key_Type;
                Value       : in     GCharacter);

   procedure On_Character_Up_Handler (Window  : in out ex_multi_line_edit_box_type;
                                      Handler : in Character_Event);

   procedure Fire_On_Character_Up (Window      : in out ex_multi_line_edit_box_type;
                                   Special_Key : in     Gwindows.Windows.Special_Key_Type;
                                   Value       : in     GCharacter);

   procedure On_Character_Down_Handler (Window  : in out ex_multi_line_edit_box_type;
                                        Handler : in Character_Event);

   procedure Fire_On_Character_Down (Window      : in out ex_multi_line_edit_box_type;
                                     Special_Key : in     Gwindows.Windows.Special_Key_Type;
                                     Value       : in     GCharacter);

   procedure On_Character_Down (Window      : in out ex_multi_line_edit_box_type;
                                Special_Key : in     Gwindows.Windows.Special_Key_Type;
                                Value       : in     GCharacter);

   procedure On_Character_Up (Window      : in out ex_multi_line_edit_box_type;
                              Special_Key : in     Gwindows.Windows.Special_Key_Type;
                              Value       : in     GCharacter);


private

   procedure On_Message (Window       : in out ex_multi_line_edit_box_type;
                         message      : in     Interfaces.C.unsigned;
                         wParam       : in     Interfaces.C.int;
                         lParam       : in     Interfaces.C.int;
                         Return_Value : in out Interfaces.C.long);

   type Ex_Multi_Line_Edit_Box_Type is
        new Multi_Line_Edit_Box_Type with
         record
            On_Character_Up_Event   : Character_Event := null;
            On_Character_Down_Event : Character_Event := null;
         end record;

end Gwindows.Edit_Boxes.Ex_Multi_Line_Edit_Boxes;
